<?php

header('Content-Type: text/html; charset=utf-8');

mb_internal_encoding("UTF-8");

//include 'correccionCombinada.php';
//include 'tratamientoPrevio.php';
include 'corrOrto_dialogo.php';
//include 'expresionesEquivalentes.php';
include 'funcionesCompartidas.php';
//include 'wordBoundary.php';

$ex = urldecode($_GET["e"]); 
$or = urldecode($_GET["o"]); 
$corr = $_GET["c"];

$or = trim($or);

if(!mb_check_encoding($or, 'UTF-8')) $or = utf8_encode($or);
if(!mb_check_encoding($ex, 'UTF-8')) $ex = utf8_encode($ex);

/*
$ex="(hábil:2)";
$or="aviles";
$corr="auto";
*/


$vuelta = 1;

$raices = array();
$palsDesc = array();
$corrsXPal = array();

// Para hacer sugerencia de corrección
$objPalsCorrs = array();
$objPalsRaices = array();
$raicesMatched = array();


$frases = mb_split('[.,;:¿?!¡]+',$or);

// PASO 0: Recuperar sólo las palabras y guardar signos de puntuación en un array
$pals = separarPalsFrase($frases);
$palsYSignos = separarPalsYSignos();


function separarPalsFrase($frases){
	
	global $corrsXPal;
	
	$arr2D = array();
	$re1 = '/([\w\dáéíóúüñÁÉÍÓÚÜÑ]+)/i';
	
	for($f=0;$f<count($frases);$f++){
		array_push($corrsXPal,array());
		$arr = array();
		preg_match_all($re1,$frases[$f],$matches,PREG_OFFSET_CAPTURE);
		$matchesPals = $matches[1];
		for($i=0;$i<count($matchesPals);$i++){
			$palabra = $matchesPals[$i][0];
			array_push($arr,$palabra);
			$arrCorrs = array();
			array_push($corrsXPal[$f],array($arrCorrs));
		}
		array_push($arr2D,$arr);
	}
	
	return $arr2D;
}

//Esto sirve para la reconstrucción posterior del texto, con correcciones.
function separarPalsYSignos(){
	
	global $or;
	$palsYSignos = array();

	$re2 = '/(([\s\.,;:¿\?¡\!]){1}|([\w\dáéíóúüñÁÉÍÓÚÜÑ]+))/i';
	preg_match_all($re2,$or,$matches,PREG_OFFSET_CAPTURE);
	$matchesAll = $matches[1];
	for($i=0;$i<count($matchesAll);$i++){
		$ente = $matchesAll[$i][0];
		array_push($palsYSignos,$ente);
	}
	
	return $palsYSignos;
}


// PASO 1: Conseguir forma canónica de las palabras; de ser necesario previa corrección ortográfica.

getLemas1();

function getLemas1(){
	
	global $pals,$palsDesc,$raices;
	global $objPalsCorrs,$objPalsRaices;
	global $corrsXPal;
        global $corr,$vuelta;
	
	for($f=0;$f<count($pals);$f++){
		
		$raicesFrase = array();
		
		for($i=0;$i<count($pals[$f]);$i++){
			
			if($pals[$f][$i]!=""){

				$pal = strToLc($pals[$f][$i]);
				array_push($raicesFrase,$pal);
				
				$matches = consultDB($pal,"morf_utf8","raiz");
									
                                if(count($matches)==0){
					$matches = dbSecundarias($pal,"raiz");
					if(count($matches)==0){
						array_push($palsDesc,$pal);
						if($corr!="off"){	
							$sugsCorr = array();	
							$corrsXPal[$f][$i] = getCorr($pal,$corrsXPal[$f][$i],$vuelta);
							foreach($corrsXPal[$f][$i] as $nivel=>$sugs){
							    $sugsCorr = array_merge((array)$sugsCorr,(array)$sugs);
							}
							sort($sugsCorr);
							$sugsCorr = quitarDupl($sugsCorr);
							$objCorrs = array($pal=>$sugsCorr);
							
							$lemas = getLemasCorrs($sugsCorr);
							foreach($lemas as $lema){
								array_push($raicesFrase,$lema);
							}
							
						} else {
							$objCorrs = array($pal=>array());
						}						
					} else {					
						foreach($matches as $lema){
							array_push($raicesFrase,$lema);
						}
						$objPalsRaices[$pal]=$matches;	
						$objCorrs = array($pal=>array());
					}	
				} else {
					foreach($matches as $lema){
						array_push($raicesFrase,$lema);
					}
					$objPalsRaices[$pal]=$matches;
					$objCorrs = array($pal=>array());
				}
				
				array_push($objPalsCorrs,$objCorrs);
			}
		}
				
		//HAY QUE QUITAR DUPLICACIONES DE PALABRAS SEGUIDAS. Ej.: y y el el él primero primero ser ser hez azul azul y y el el él segundo segundo ser ser hez verde verde
                $raicesFrase = quitarDupl($raicesFrase);
		array_push($raices,$raicesFrase);
	}
}


function getLemasCorrs($arr){
	
	global $objPalsRaices;
	
	$allLemas = array();
	
	foreach($arr as $corr){
		
		$lemas = consultDB($corr,"morf_utf8","raiz");
		
		if(count($lemas)==0){
			$lemas = dbSecundarias($corr,"raiz");
		}
		
		$objPalsRaices[$corr]=$lemas;
		
		$allLemas = array_merge((array)$allLemas,(array)$lemas);
		
	}
		
	return $allLemas;
}				



//// PASO 2: Preparar la expresión lógica

//a. Agregar expresiones equivalentes
///ESTO SE HARÁ EN LA INTERFAZ DE EDICIÓN, PARA GUARDAR LAS CLAVES COMPLETAS EN EL XML Y NO TENER QUE HACER EL PROCESAMIENTO EN RUNTIME.
/*
if($ex!="(NEG)" && $ex!="(AFIR)" && $ex!="(DUDA)"){
	$ex = addExprEq($ex);
}
*/


//b. Sustituir AND,OR,NOT,ANDNOT por los respectivos signos

$patrones = array();
$patrones[0] = '/ANDNOT/';
$patrones[1] = '/AND/';
$patrones[2] = '/OR/';
$patrones[3] = '/NOT/';
$patrones[4] = '/NEG/';
$patrones[5] = '/MAS/';
$patrones[6] = '/CAUSA/';

$sustituciones = array();
$sustituciones[0] = '&!';
$sustituciones[1] = '&&';
$sustituciones[2] = '//';
$sustituciones[3] = '!';
$sustituciones[4] = '#';
$sustituciones[5] = '++';
$sustituciones[6] = '->';


if($ex!="(NEG)" && $ex!="(AFIR)" && $ex!="(DUDA)"){
	$ex = preg_replace($patrones, $sustituciones, $ex);
}



// PASO 3: TOKENIZATION


if($ex!="(NEG)" && $ex!="(AFIR)" && $ex!="(DUDA)"){
	$toks = getTokens();
}



function getTokens(){
	
	global $ex;
		
	$toks = array();
	$reLetra = '/[\w\d:áéíóúüñ\-]/i';
	$reOp = '/[&\/\!\#\+\-\>]/';
	$reOpCompl = '/(\+\+|&&|\/\/|&\!|\!|\#|\-\>)/';
	$pal = "";
	$op = "";
	
	for($l=0;$l<strlen($ex);$l++){
		
		/////EN FLASH, ESTO CAUSABA PROBLEMAS (NO RECONOCÍA CARACTERES CON ACENTOS)
		/*if( preg_match($reLetra,substr($ex,$l,1)) ){
			$pal.=substr($ex,$l,1);
		} else*/
		
		if( preg_match($reOp,substr($ex,$l,1)) ){
			if($pal!=""){
				$pal = getPalsAfins($pal);
				array_push($toks,$pal);
				//echo " pal token=".$pal;
				$pal = "";
			}
			$op.=substr($ex,$l,1);
			if(preg_match($reOpCompl,$op)){
				array_push($toks,$op);
				$op = "";
			}
		} else if(substr($ex,$l,1)=="("){
			array_push($toks,"(");
		} else if(substr($ex,$l,1)==")"){
			if($pal!=""){
				$pal = getPalsAfins($pal);
				array_push($toks,$pal);
				//echo " pal token=".$pal;
				$pal = "";
			}
			array_push($toks,")");
		} else {
			$pal.=substr($ex,$l,1);
		}
	}
	
	return $toks;
}


//// PASO 4: Si $d>0 --> get palabras afines a las palabras encontradas en la expresión

function getPalsAfins($pal){
	
	$palsAfins = array();
	$antonimos = array();
		
	if($pal!=""){
		
		$d = 0;
		$tipoPal = "";
		$arr = split(":",$pal);
		$pal = $arr[0];
		if(count($arr)==3){
			$tipoPal = $arr[1];
			$d = $arr[2];
		} else if(count($arr)==2){
			$d = $arr[1];
		}
		
		///if $pal != synset
		if(preg_match('/\d{8}/',$pal)==FALSE){
			array_push($palsAfins,$pal);
		}
		if($d>=1){
	
			if(preg_match('/\d{8}/',$pal)){
				$synsets = array($pal);
			} else {
				$synsets = getSynsets($pal,$tipoPal);
			}
			for($i=0;$i<count($synsets);$i++){
				$palsAfins = array_merge((array)$palsAfins,(array)getSinonimos($synsets[$i]));
				if($d>=2){
					$palsAfins = array_merge((array)$palsAfins,(array)getDemasRels($synsets[$i]));
					$antonimos = array_merge((array)$antonimos,(array)getAntonimos($synsets[$i]));
				}
			}
			
			$palsAfins = limpiar($palsAfins);
			$antonimos = limpiar($antonimos);

			
			if($d==3){
				$arrVSA = array();
				foreach($palsAfins as $p){
					$arrVSA = array_merge((array)$arrVSA,(array)getVerbSustAdj($p));
				}
			}
			$palsAfins = array_merge((array)$palsAfins,(array)$arrVSA);
			
			sort($palsAfins);
			$palsAfins = quitarDupl($palsAfins);
		}
	}
	
	if(count($antonimos)==0){
		return join(",",$palsAfins);
	} else {
		return join(",",$palsAfins)."--".join(",",$antonimos);
	}
}


function limpiar($array){
	//agregar el infinitivo sin "se" de los verbos reflexivos, por ej. apoderarse->apoderar
	$verbRefl = array();
	for($i=0;$i<count($array);$i++){
		if(preg_match('/[aei]rse$/',$array[$i])){
			array_push($verbRefl,substr($array[$i],0,-2));
		}
	}
	$array = array_merge((array)$array,(array)$verbRefl);
	sort($array);
	$array = quitarDupl($array);
	return $array;
}


function getSynsets($pal,$tipoPal){
	
	
	$dbhWN = connectToDB();
	mysql_select_db("esWN", $dbhWN);

	$arrSS = array();
	$query  = "SELECT * FROM eswn_variant_utf8 WHERE word='$pal'"; 
	$result = mysql_query($query,$dbhWN);
	while($row = mysql_fetch_array($result)){
		if($tipoPal=="" || $tipoPal==$row['pos']){
			array_push($arrSS,$row['offset']);
		}
	}
	
	mysql_close($dbhWN);
	
	return $arrSS;
}

function getSinonimos($ss){

	$dbhWN = connectToDB();
	mysql_select_db("esWN", $dbhWN);
	
	$sinonimos = array();
	
	$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$ss'"; 
	$result = mysql_query($query,$dbhWN);
	while($row = mysql_fetch_array($result)){
		$word = $row['word'];
		$word = preg_replace('/_/',' ', $word);
		array_push($sinonimos,$word);
	}
	
	mysql_close($dbhWN);
	
	return $sinonimos;
}

function getDemasRels($ss){
	
	$dbhWN = connectToDB();
	mysql_select_db("esWN", $dbhWN);
	
	$newSynsets=array();
	$newPals=array();
	
	$query  = "SELECT * FROM eswn_relation WHERE ( (sourceSynset='$ss') OR (targetSynset='$ss') )";
	$result = mysql_query($query,$dbhWN);
	while($row = mysql_fetch_array($result)){
		if($row['relation']!='near_antonym'){
			if($row['targetSynset']==$ss){
				array_push($newSynsets,$row['sourceSynset']);
			} else {
				array_push($newSynsets,$row['targetSynset']);
			}
		}
	}
	
	for($n=0;$n<count($newSynsets);$n++){
		$newSs = $newSynsets[$n];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$newSs'";
		$result = mysql_query($query,$dbhWN);
		while($row = mysql_fetch_array($result)){
			$word = $row['word'];
			$word = preg_replace('/_/', ' ', $word);
			array_push($newPals,$word);
		}
	}
	
	mysql_close($dbhWN);
	
	return $newPals;
}

function getAntonimos($ss){
	
	$dbhWN = connectToDB();
	mysql_select_db("esWN", $dbhWN);
	
	$ssAntonimos=array();
	$antonimos=array();
	
	$query  = "SELECT * FROM eswn_relation WHERE ( (sourceSynset='$ss') OR (targetSynset='$ss') )";
	$result = mysql_query($query,$dbhWN);
	while($row = mysql_fetch_array($result)){
		if($row['relation']=='near_antonym'){
			if($row['targetSynset']==$ss){
				array_push($ssAntonimos,$row['sourceSynset']);
			} else {
				array_push($ssAntonimos,$row['targetSynset']);
			}
		}
	}
	
	for($a=0;$a<count($ssAntonimos);$a++){
		$ssAnt = $ssAntonimos[$a];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$ssAnt'";
		$result = mysql_query($query,$dbhWN);
		while($row = mysql_fetch_array($result)){
			$word = $row['word'];
			$word = preg_replace('/_/', ' ', $word);
			array_push($antonimos,$word);
		}
	}
	
	mysql_close($dbhWN);
	
	return $antonimos;
}



// PASO 5: PARSEAR EXPRESIÓN Y ANALIZAR

$OS = array(); //operator stack
$WS = array(); //word stack
$error = 0;
$match = FALSE;
$fIni = -1;
$fFin = -1;
$pIni = -1;
$pFin = -1;
$arrPos = array();
    
if($ex=="(DUDA)"){
    $tok = "no sé,no se,no lo sé,no lo se,ni idea,quien sabe,quién sabe,ve tu a saber,ve tú a saber";
    $nodo = new Node();
    $nodo->setToken($tok);
    array_push($WS,$nodo);
} else if($ex=="(NEG)"){
        $tokNeg = "no,nop,nope,nada,nel,en absoluto,negativo,de ninguna manera,de ningún modo,dos tres,mas o menos,más o menos";
        $tokDuda = "no sé,no se,no lo sé,no lo se,ni idea,quien sabe,quién sabe,ve tu a saber,ve tú a saber";
        $nodoNeg = new Node();
        $nodoNeg->setToken($tokNeg);
        $nodoDuda = new Node();
        $nodoDuda->setToken($tokDuda);
        $nodo = new Node();
        $nodo->setToken("&!");
        $nodo->setLeft($nodoNeg);
        $nodo->setRight($nodoDuda);
        array_push($WS,$nodo);
} else if($ex=="(AFIR)"){
        $tokAfir = "si,sí,sip,sipi,aja,ajá,claro,ok,venga,simon,simón,por supuesto,sin duda,seguro,seguramente,cierto,ciertamente,de acuerdo,así es,obviamente,obvio,evidentemente,afirmativo";
        $tokNeg = "no,nop,nope,nada,nel,en absoluto,negativo,de ninguna manera,de ningún modo";
        $nodoAfir = new Node();
        $nodoAfir->setToken($tokAfir);
        $nodoNeg = new Node();
        $nodoNeg->setToken($tokNeg);
        $nodo = new Node();
        $nodo->setToken("&!");
        $nodo->setLeft($nodoAfir);
        //Para interpretar bien expresiones como: claro que no, obviamente no, ...
        $nodo->setRight($nodoNeg);
        array_push($WS,$nodo);
} else {
        parsear();
}


if($error==0){
	$match = $WS[0]->analizar();
}


//// OUTPUT

printOutput();

function printOutput(){
    
    global $error,$match,$palsDesc,$vuelta,$corr,$pals;

    if($error==0){
            if($match==TRUE){
                    //if(count($palsDesc)>0){
		    if($corr=="on"){
                            echo "true|".getCorreccionSugerida(); //$raicesMatched
                    } else {
                            echo "true|";
                    }
            } else {
		    if($corr!="off" && $vuelta==1){
                        $vuelta++;
                        segundaVuelta();
                    } else {
                    /*if(count($palsDesc)>0){
                            echo "false|".getCorreccionSugerida();
                    } else {*/
                            echo "false|" .join(",",$pals);
                    }
            }
    } else {
            echo "Error ".$error." en expresión lógica|".join(",",$palsDesc);
    }
}


//// FUNCIONES

function segundaVuelta(){

    global $pals,$frases;
    global $objPalsCorrs,$objPalsRaices,$raicesMatched;
    global $match,$error;
    global $WS;
    
    $objPalsCorrs = array();
    
    $match = FALSE;
    
    $raices = array();
    getLemas2();
    
    $raicesMatched = array();
    
    if($error==0){
	$match = $WS[0]->analizar();
    }
    
    printOutput();
}


function getLemas2(){
	
	global $pals,$raices;
	global $objPalsCorrs,$objPalsRaices;
	global $corrsXPal;
        global $corr,$vuelta;
	
	for($f=0;$f<count($pals);$f++){
		
		$raicesFrase = array();
		
		for($i=0;$i<count($pals[$f]);$i++){
			
			if($pals[$f][$i]!=""){
				
				$pal = strToLc($pals[$f][$i]);
				
				//Palabra existente --> aún no hay correcciones
				if(count($corrsXPal[$f][$i])==0){
					
					$raicesPal = $objPalsRaices[$pal];
					array_push($raicesPal,$pal);
					
					$matched = 0;
					foreach($raicesPal as $raiz){
						if(in_array($raiz,$raicesMatched)){
							$matched = 1;
							break;
						}
					}
					if($matched==0){
						$sugsCorr = array();	
						$corrsXPal[$f][$i] = getCorr($pal,$corrsXPal[$f][$i],1);
						foreach($corrsXPal[$f][$i] as $nivel=>$sugs){
						    $sugsCorr = array_merge((array)$sugsCorr,(array)$sugs);
						}
						sort($sugsCorr);
						$sugsCorr = quitarDupl($sugsCorr);
						$objCorrs = array($pal=>$sugsCorr);
						
						$lemas = getLemasCorrs($sugsCorr);
						foreach($lemas as $lema){
							array_push($raicesPal,$lema);
						}
					} else {
						$objCorrs = array($pal=>array());	
					}
					
				} else {
					//Palabras no existentes que ya se sometieron a una vuelta de corr orto.
					$raicesPal = array($pal);
					
					$sugsCorr = array();
					$corrsXPal[$f][$i] = getCorr($pal,$corrsXPal[$f][$i],2);
					foreach($corrsXPal[$f][$i] as $nivel=>$sugs){
					    $sugsCorr = array_merge((array)$sugsCorr,(array)$sugs);
					}
					sort($sugsCorr);
					$sugsCorr = quitarDupl($sugsCorr);
					$objCorrs = array($pal=>$sugsCorr);
					
					$lemas = getLemasCorrs($sugsCorr);
					foreach($lemas as $lema){
						array_push($raicesPal,$lema);
					}
				}
				
				array_push($objPalsCorrs,$objCorrs);
				$raicesFrase = array_merge((array)$raicesFrase,(array)$raicesPal);									
                                
			}
		}
				
		//HAY QUE QUITAR DUPLICACIONES DE PALABRAS SEGUIDAS. Ej.: y y el el él primero primero ser ser hez azul azul y y el el él segundo segundo ser ser hez verde verde
                $raicesFrase = quitarDupl($raicesFrase);
		array_push($raices,$raicesFrase);
	}
}



function getCorreccionSugerida(){
	
	global $objPalsCorrs, $raicesMatched, $objPalsRaices, $palsYSignos;
	
	$palsCorrs = array();
	
	for($i=0;$i<count($objPalsCorrs);$i++){
		foreach($objPalsCorrs[$i] as $pal=>$arr){
			if(count($arr)==0){
				if($i==0){
					$pal = ucfirst($pal);
				}
				array_push($palsCorrs,$pal);
			} else if(count($arr)==1){
				$corr = $arr[0];
				if($i==0){
					$corr = ucfirst($corr);
				}
				array_push($palsCorrs,$corr);
			} else {
				$ok=FALSE;
				for($j=0;$j<count($arr);$j++){
					$corr = $arr[$j];
					$raices = $objPalsRaices[$corr];
					for($r=0;$r<count($raicesMatched);$r++){
						if(in_array($raicesMatched[$r],$raices)){
							if($i==0){
								$corr = ucfirst($corr);
							}
							array_push($palsCorrs,$corr);
							$ok=TRUE;
							break;
						}
					}
					if($ok){
						break;
					}
				}
				if($ok==FALSE){
					if($i==0){
						$pal = ucfirst($pal);
					}
					array_push($palsCorrs,$pal);
				}
			}
		}
	}
	
	$str = "";
	$rePal = '/[\w\dáéíóúüñÁÉÍÓÚÜÑ-]+/';
			
	for($i=0;$i<count($palsYSignos);$i++){
		$ente = $palsYSignos[$i];
		if(preg_match($rePal,$ente)){
			$pal = array_shift($palsCorrs);
			$str.=$pal;
		} else {
			$str.=$ente;
		}
	}
	
	return $str;
}



function parsear(){
	
	global $toks;
	global $OS,$WS;
	global $error,$match;

	$countLp = 0;

	for($i=0;$i<count($toks);$i++){
		$tok = $toks[$i];
                //echo $tok." ";
		$nodo = new Node();
		$nodo->setToken($tok);
		if($nodo->type==$nodo->lp){
			array_push($OS,$nodo);
			$countLp++;
		} else if($nodo->type==$nodo->op){
			$opAnt = $OS[count($OS)-1];
			// si el elemento anterior en OS es un operador y es del mismo o menor valor que el del presente nodo
			if(count($OS)>0 && $opAnt->type==$opAnt->op && $nodo->valor<=$opAnt->valor){
				crearNodePorPrioridadSignos();
			}
			array_push($OS,$nodo);
		} else if($nodo->type==$nodo->pal){
			array_push($WS,$nodo);
		} else if($nodo->type==$nodo->rp){
			if($countLp>0){
				crearNodoDesdeRP();
				$countLp--;
				// checar si operador anterior es NEG (0) o NOT (1) -> prioridad
				$opAnt = $OS[count($OS)-1];
				if(count($OS)>0 && $opAnt->type==$opAnt->op && $opAnt->valor<2){
					crearNodePorPrioridadSignos();
				}
			} else {
				$error=1;
			}
		}
	}
	
	if($countLp>0){
		$error=2;
	}
	
	if($error==0 && count($OS)>0){
		toOneNode();
	}

}


function crearNodePorPrioridadSignos(){
	
	global $OS,$WS;
	global $error;
	
	$nodo = array_pop($OS);
	
	if($nodo->valor<2){
		if(count($WS)>=1){
			$nodo->setLeft(array_pop($WS));
			array_push($WS,$nodo);
		} else {
			$error=3;
		}
	} else {
		if(count($WS)>=2){
			$nodo->setRight(array_pop($WS));
			$nodo->setLeft(array_pop($WS));
			array_push($WS,$nodo);
		} else {
			$error=4;
		}
	}
}


function crearNodoDesdeRP(){
	        
	global $OS,$WS;
	global $error;
        
        $desfactorizar = FALSE;
	
	$opAnt = $OS[count($OS)-1];
	if($opAnt->type==$opAnt->lp){
                //en caso de que sólo hay una clave entre los paréntesis
		array_pop($OS);
	} else {
		$nodo = array_pop($OS);
                
		if(count($WS)>=2){
                    
                        //AQUI HAY QUE desfactorizar NEG: NEG(clave1ORclave2) --> NEG(clave1)OR(NEG(clave2))
                        if(count($OS)>1 && $OS[count($OS)-2]->type==$OS[count($OS)-2]->op && $OS[count($OS)-2]->valor==0){
                            $desfactorizar = TRUE;
                            $nodoNegRight = new Node();
                            $nodoNegRight->setToken("#");
                            $nodoNegRight->setLeft(array_pop($WS));
                            $nodoNegLeft = new Node();
                            $nodoNegLeft->setToken("#");
                            $nodoNegLeft->setLeft(array_pop($WS));
                            $nodo->setRight($nodoNegRight);
                            $nodo->setLeft($nodoNegLeft);
                        } else {
                            $nodo->setRight(array_pop($WS));
                            $nodo->setLeft(array_pop($WS));
                        }

			array_push($WS,$nodo);
			if($OS[count($OS)-1]->type==$OS[count($OS)-1]->lp){
				array_pop($OS);
                                if($desfactorizar){
                                    array_pop($OS);
                                }
			} else {
				$error=5;
			}
		} else {
			$error=6;
		}
	}
}

function toOneNode(){
	global $OS;
	crearNodePorPrioridadSignos();
	if(count($OS)>0){
		toOneNode();
	}
}



///////////// CLASE NODE //////////////

class Node{
	
	public $token;
	public $type;
	public $valor;
	public $left;
	public $right;
	
	public $lp = 0;
	public $rp = 1;
	public $op = 2;
	public $pal = 3;
	
	private $match = TRUE;
	
	public function setToken($t) { 
		$this->token = $t;
		$this->setType();	
	}
	
	private function setType(){
		
		if($this->token == "("){
			$this->type = $this->lp;
		} else if($this->token == ")"){
			$this->type = $this->rp;	
		} else if(preg_match('/(\+\+|-\>|&&|\/\/|&\!|\!|#)/',$this->token)){
			$this->type = $this->op;
			$this->setValor();
		} else {
			$this->type = $this->pal;
		}
	}
	
	public function setValor(){
		if($this->token=="#"){
			$this->valor = 0;
		} else if($this->token=="!"){
			$this->valor = 1;
		} else if($this->token=="&&" || $this->token=="&!"){
			$this->valor = 2;
		} else if($this->token=="//" || $this->token=="++" || $this->token=="->"){
			$this->valor = 3;
		}
	}
	
	public function setLeft($l) { $this->left = $l; }
	
	public function setRight($r) { $this->right = $r; }
	
	public function getToken() { return $this->token; }
	
	public function getType() { return $this->type; }
	
	public function getValor() { return $this->valor; }
	
	
	public function analizar(){

		if($this->left!=null && $this->right!=null) {
			switch ($this->token) {
                                case "->":
                                                $this->match = $this->left->analizar() && $this->checarPos() && $this->right->analizar() && $this->checarPos() && $this->checarCausa();
						break;
				case "++": //$this->match = $this->left->analizar() && $this->eliminar() && $this->right->analizar();
                                            $this->match = $this->left->analizar() && $this->checarPos() && $this->right->analizar() && $this->checarPos();
						break;
				case "&&" : $this->match = $this->left->analizar() && $this->right->analizar();
						break;
				case "//" : $this->match = $this->left->analizar() || $this->right->analizar();
						break;
				case "&!" : $this->match = $this->left->analizar() && (!$this->right->analizar());
						break;
			}
		} else if($this->left!=null){
			switch ($this->token) {
				case "!" :	$this->match = !($this->left->analizar());
						break;
				case "#" :	$this->match = $this->negacion($this->left->token,true);
						break;
			}
		} else {
			$this->match = $this->checkMatch($this->token);
		}
		
		return $this->match;
	}
	
        
        private function checarPos(){
      
            global $raices;
	    global $fIni,$fFin,$pIni,$pFin;
            global $arrPos;
            
            $ok = TRUE;
            
            //cuando hay 3x MAS, checarPos se repitirá y hay que evitar que se agreguen los mismos valores 2 veces
            if($fIni!=-1){
            
                $arr = array($fIni,$fFin,$pIni,$pFin);
                array_push($arrPos,$arr);
                
                //Hacer un gran array de todas las raices
                $pals = array();
                for($i=0;$i<count($raices);$i++){
                    $pals = array_merge($pals,$raices[$i]);
                }
                
                //¿El echo hace la diferencia?????
                echo "";
                
                //Hay que checar y comparar cada 2 conjuntos de posiciones
                for($i=0;$i<count($arrPos)-1;$i++){
                    
                    $pos1 = $arrPos[$i];
                    $pos2 = $arrPos[$i+1];
 
                    //get posIni y posFin "global" para cada array
                    if($pos1[0]==$pos1[1]){ //fIni == fFin
                        $pIni1 = $pos1[2];
                        $pFin1 = $pos1[3];
                    } else {
                        $n = 0;
                        for($j=0;$j<count($raices);$j++){  
                            if($j==$pos1[0]){
                                $pIni1 = $n+$pos1[2];
                            } else if($j==$pos1[1]){
                                $pFin1 = $n+$pos1[3];
                            }
                            $n+=count($raices[$j]);
                        }
                    }
                    
                    if($pos2[0]==$pos2[1]){ //fIni == fFin
                        $pIni2 = $pos2[2];
                        $pFin2 = $pos2[3];
                    } else {
                        $n = 0;
                        for($j=0;$j<count($raices);$j++){  
                            if($j==$pos2[0]){
                                $pIni2 = $n+$pos2[2];
                            } else if($j==$pos2[1]){
                                $pFin2 = $n+$pos2[3];
                            }
                            $n+=count($raices[$j]);
                        }
                    }
                    
                    //Se tiene que cumplir: (pIni1 && pFin1 < pIni2)  OR  (pIni1 && pFin1 > pFin2)
                    if( ( $pIni1<$pIni2 && $pFin1<$pIni2 ) || ( $pIni1>$pFin2 && $pFin1>$pFin2 ) ){
                        $ok=TRUE;
                    } else {
                        $ok=FALSE;
                        break;
                    }
                    
                }
    
                $fIni = -1;
                $fFin = -1;
                $pIni = -1;
                $pFin = -1;
            }

            return $ok;
            
        }
        
        private function checarCausa(){
            
            global $frases;
            
            $ok = FALSE;
            
            //En causa 1 y 2 hay que agregar "POR" seguido de un infinitivo. También: TAN ... que ...
            $cnctrsCausa1 = array("dado que","ya que","porque","por que","a causa de","debido a","en vista de","como");
            $cnctrsCausa2 = array("dado que","ya que","porque","por que","a causa de","debido a","en vista de","pues");
            $cnctrsEfecto2 = array("por eso","por esto","por lo mismo","por lo que","por lo cual","debido a eso","debido a lo que","entonces","caus");
            
            // $cnctrsCausa1  
            for($j=0;$j<count($cnctrsCausa1);$j++){
                $re = "/$cnctrsCausa1[$j]/i";
                for($f=0;$f<count($frases);$f++){
                    preg_match_all($re,$frases[$f],$matches,PREG_OFFSET_CAPTURE);
                    if($matches[0][0]!=""){
                        $ok = $this->checkPosCausa("c1",$matches[0][0][1],$f);
                        if($ok){
                            break;
                        }
                    }
                }
            }
        
            if($ok==FALSE){
                // $cnctrsCausa2 
                for($j=0;$j<count($cnctrsCausa2);$j++){
                    $re = "/$cnctrsCausa2[$j]/i";
                    for($f=0;$f<count($frases);$f++){
                        preg_match_all($re,$frases[$f],$matches,PREG_OFFSET_CAPTURE);
                        if($matches[0][0]!=""){
                            $ok = $this->checkPosCausa("c2",$matches[0][0][1],$f);
                            if($ok){
                                break;
                            }
                        }
                    }
                }
            }
            
            if($ok==FALSE){
                // $cnctrsEfecto2 
                for($j=0;$j<count($cnctrsEfecto2);$j++){
                    $re = "/$cnctrsEfecto2[$j]/i";
                    for($f=0;$f<count($frases);$f++){
                        preg_match_all($re,$frases[$f],$matches,PREG_OFFSET_CAPTURE);
                        if($matches[0][0]!=""){
                            $ok = $this->checkPosCausa("e2",$matches[0][0][1],$f);
                            if($ok){
                                break;
                            }
                        }
                    }
                }
            }
            
            return $ok;
        }
        
        
        private function checkPosCausa($tipo,$offset,$numFrase){
            
            global $frases;
            global $arrPos;
            
            $ok = FALSE;
            
            //El operdador CAUSA sólo puede unir dos expresiones
            if(count($arrPos)==2){
                
                $posC = $arrPos[0];
                $posE = $arrPos[1];
                $pIniC = $this->getOffset($numFrase,$posC[2]);
                $pIniE = $this->getOffset($numFrase,$posE[2]);
                
                //echo "tipo=$tipo ";
                //echo $posC[0]." ".$posE[0]." ";
                
                if($tipo=="c1"){
                    //$pIniC debe ser menor a $pIniE && $offset debe ser menor a $pIniC
                    if( $posC[0] < $posE[0] || ($posC[0] == $posE[0] && $pIniC < $pIniE) ){
                        if($numFrase < $posC[0]){
                            $ok=TRUE;
                        } else if($numFrase == $posC[0] && $offset < $pIniC){
                            $ok=TRUE;
                        } 
                    }
                } else if($tipo=="c2"){
                    //$pIniE debe ser menor a $pIniC && $offset debe ser menor a $pIniC 
                    if( $posE[0] < $posC[0] || ($posE[0] == $posC[0] && $pIniE < $pIniC) ){
                        if($numFrase < $posC[0]){
                            $ok=TRUE;
                        } else if($numFrase == $posC[0] && $offset < $pIniC){
                            $ok=TRUE;
                        } 
                    }
                } else if($tipo=="e2"){
                    //$pIniC debe ser menor a $pIniE && $offset debe ser menor a $pIniE
                    if( $posC[0] < $posE[0] || ($posC[0] == $posE[0] && $pIniC < $pIniE) ){
                        if($numFrase < $posE[0]){
                            $ok=TRUE;
                        } else if($numFrase == $posE[0] && $offset < $pIniE){
                            $ok=TRUE;
                        } 
                    }
                }
                
            }

            return $ok;
        }
        
        
        private function getOffset($numFrase,$numPal){
            
            global $frases;

            $arrFrase = split(" ",$frases[$numFrase]);
            $offset = -1;
            for($i=0;$i<$numPal;$i++){
                 $offset+=mb_strlen($arrFrase[$i])+1;
            }
            
            return $offset;
        }
	
	private function negacion($strPals,$quitarNeg){
		
		/* 
		Considerar diferencia entre:
			
			1. No creo que lo logre nunca/jamás != No creo que nunca/jamás lo logre
			2. No creo que lo logre != No creo que no lo logre
			   No digo que nadie lo sepa == Alguien lo sabe
			   No digo que nada de esto sea cierto == Algo es cierto
			
			3. Ni lo creo ni me importa = No lo creo, no me importa
			4. No me gusta ni el pescado ni los mariscos == Me gusta ni el pescado ni los mariscos
			5. No creo que nadie lo sepa == No creo que lo sepa nadie
			6. No tiene ningún caso == No tiene caso == no tiene caso ninguno
			7. No lo encuentro en ninguna parte == En ninguna parte lo encuentro
			8. No hay nadie a quien quiera
			9. Hay alguien a quien no quiero.
			10. No hay nadie a quien no quiera.
		
			
		¡Hay que separar las oraciones coordinadas y yuxtapuestas (verbos separados por punto, coma, punto y coma o conjunción), y las negaciones precedidas por coma!
		Ej: No, dije que no estoy de acuerdo.
		*/
		
		global $raices,$raicesMatched,$frases;
		
		$hayNeg = FALSE;
		
		$negs = array("no","nunca","jamás","jamas","nada","nadie","ningún","ningun","ninguno","ninguna","ni","nul","sin");
		$nexosSubord = array("que","quien","donde","cuando","cual","cuales");
				
		if(preg_match('/--/',$strPals)){
			$arr = split("--",$strPals);
			$pals = split(",",$arr[0]);
			$ants = split(",",$arr[1]);
		} else {
			$pals = split(",",$strPals);
			$ants = array();
		}
		
		
		$mp = -1; //$mp=matchpoint
		$mf = -1; //$mf=matchfrase
				
		// quizá haya que tomar en cuenta todas las incidencias, no sólo la primera
		for($f=0;$f<count($raices);$f++){
			for($i=0;$i<count($raices[$f]);$i++){
				for($j=0;$j<count($pals);$j++){
					if($raices[$f][$i]==$pals[$j]){
						$mp=$i;
						$mf=$f;
						break;
					}
				}
				if($mp!=-1){
					break;
				}
			}
			if($mp!=-1){
				break;
			}
		}
		
		
		///SE AGREGÓ POR SI HAY EXPRESIONES DE MÁS DE 1 PALABRA, EJ. DOS O MÁS
		if($mp==-1){
			for($f=0;$f<count($frases);$f++){
				for($j=0;$j<count($pals);$j++){
					$re = "/$pals[$j]/i";
					preg_match($re, $frases[$f], $matches, PREG_OFFSET_CAPTURE);
					if(count($matches)>0){
						$mp = $matches[0][1];
						$mf = $f;
						break;
					}
				}
				if($mp!=-1){
					break;
				}
			}
		}
		
		
		//negación antes y después de subordinación (no creo que no ...)
		$negAnt=0;
		$negDesp=0;
		$subord=FALSE;
		$mpSub=-1;
		
		for($p=0;$p<$mp;$p++){
			if(in_array($raices[$mf][$p],$negs)){
				if($subord){
					$negDesp++;	
				} else {
					$negAnt++;
				}
			}else if(in_array($raices[$mf][$p],$nexosSubord)){
				$subord=TRUE;
				$mpSub = $p;
			}
		}
				
		if( ($subord==FALSE && $negAnt>0) || 
		    ($subord==TRUE && ( ($negAnt==0 && $negDesp>0) || ($negAnt>0 && $negDesp==0) ) ) 
		  ){
			$hayNeg = TRUE;
			array_push($raicesMatched,$raices[$mf][$mp]);
		}
				
		//Para que no cuente la negación de fruta en "no me gusta la fruta" =? NEG(querer:3)AND(fruta:2)
		/*if($hayNeg && $quitarNeg){
			$quitados = 0;
			for($p=0;$p<$mp;$p++){
				if(in_array($raices[$mf][$p],$negs)){
					array_splice($raices[$mf],$p,1);
					$p--;
					$quitados++;
				}
			}
			$this->asignarIniFin($mf,$mp-$quitados);
		} else if($hayNeg){
			$this->asignarIniFin($mf,$mp);
		}
                */
                
		//checar si no hay match con los antónimos sin que se nieguen
		if($hayNeg==FALSE && count($ants)>0){
			//PROBLEMA CON ELIMINAR: AÚN SI SE NIEGA, YA SE habrá quitado de raices; por eso se invirtió orden: primero negación, después checkMatch
			$hayNeg = (!$this->negacion($arr[1],false)) && $this->checkMatch($arr[1]);
		}
		
		return $hayNeg;
	}
	
	private function checkMatch($strPals){
		
		global $raices,$raicesMatched,$frases;
				
		if(preg_match('/--/',$strPals)){
			$arr = split("--",$strPals);
			$pals = split(",",$arr[0]);
			$ants = split(",",$arr[1]);
		} else {
			$pals = split(",",$strPals);
			$ants = array();
		}

		$m = FALSE;
		for($f=0;$f<count($raices);$f++){
			for($i=0;$i<count($raices[$f]);$i++){
				for($j=0;$j<count($pals);$j++){
					if($raices[$f][$i]==$pals[$j] && $this->negacion($pals[$j],false)==FALSE){
						$m = TRUE;
						array_push($raicesMatched,$raices[$f][$i]);
						$this->asignarIniFin($f,$i);
						break;
					}
				}
				if($m){
					break;	
				}
			}
			if($m){
				break;	
			}
		}
		
		///SE AGREGÓ POR SI HAY EXPRESIONES DE MÁS DE 1 PALABRA, EJ. DOS O MÁS
		if($m==FALSE){
			for($f=0;$f<count($frases);$f++){
				for($j=0;$j<count($pals);$j++){
					$re1 = "/[^\w\dáéíóúüñ]$pals[$j][^\w\dáéíóúüñ]/i";
                                        $re2 = "/^$pals[$j][^\w\dáéíóúüñ]/i";
                                        $re3 = "/[^\w\dáéíóúüñ]$pals[$j]$/i";
                                        $re4 = "/^$pals[$j]$/i";
					if((preg_match($re1,$frases[$f])|| preg_match($re2,$frases[$f]) || preg_match($re3,$frases[$f]) ||preg_match($re4,$frases[$f])) && $this->negacion($pals[$j],false)==FALSE){
						$m=TRUE;
						break;
					}
				}
				if($m){
					break;	
				}
			}
		}
		
		//If no match & grado 3 de distancia => checar si hay negación de antónimos
		if($m==FALSE && count($ants)>0){
			$m = $this->negacion($arr[1],true); //$this->negacion($arr[1],false) ????? cuál conviene???
		}
		
		return $m;
	}
	
	private function asignarIniFin($f,$p){
		
		global $fIni,$fFin,$pIni,$pFin;
		
		if($fIni==-1){
			$fIni = $f;
			$fFin = $f;
			$pIni = $p;
			$pFin = $p;
		} else {
			if($f<$fIni){
                            $fIni = $f;
                            $pIni = $p;
			} else if($f==$fIni){
                            if($p<$pIni){
                                $pIni = $p;	
                            } else if($p>$pFin){
                                $pFin = $p;
                            }
			} else if($f>$fFin){
                            $fFin = $f;
                            $pFin = $p;
			} 
		}	
	}
	
	
}



?>