<?php

header('Content-Type: text/html; charset=utf-8');
mb_internal_encoding("UTF-8");
mb_regex_encoding("UTF-8");

//getPalabrasLevenshteinPHP("modelos",1);

/// !!!!!! La función levenshtein de php no considera multibyte characters (ó, ú, ...) es decir: no los sustituye por otros. Con la función addAcentos, ya no existe ese problema.


function getPalabrasLevenshteinPHP($seed,$d){
	
	if($d>=2){
		$seeds = addAcentos($seed);
	} else {
		//$d==1 sólo se usa para la función errsFrecsLevenstein1, en la cual ya se pusieron todos los acentos (array combinaciones)
		$seeds = array();
	}
	array_push($seeds,$seed);
	
	$lSeed = mb_strlen($seed,'UTF-8');
	$lMin = $lSeed-$d;
	$lMax = $lSeed+$d;
	
	$palabras = consultarDB($seeds,"morf_utf8",$lMin,$lMax,$d);
	
	if(mb_ereg('([íi]sim|[ée]rrim)[oa]s?$',$seed)){
		$palabras = array_merge($palabras,consultarDB($seeds,"super",$lMin,$lMax,$d));
	} elseif(mb_ereg('mente$',$seed)){
		$palabras = array_merge($palabras,consultarDB($seeds,"adverb",$lMin,$lMax,$d));
	} elseif(mb_ereg('(la|las|le|les|lo|los|me|nos|os|se|te|mela|melas|mele|meles|melo|melos|nosla|noslas|nosle|nosles|noslo|noslos|osla|oslas|osle|osles|oslo|oslos|osme|osnos|sela|selas|sele|seles|selo|selos|seme|senos|seos|sete|tela|telas|tele|teles|telo|telos|teme|tenos)$',$seed)){
		$palabras = array_merge($palabras,consultarDB($seeds,"enclit",$lMin,$lMax,$d));
	}

	sort($palabras);
	$palabras = quitarDupl($palabras);

	return $palabras;
}



function consultarDB($seeds,$tabla,$lMin,$lMax,$d){
	
	$palabras = array();
	
	$dbh = connectToDB();
	mysql_select_db("morfo", $dbh);
	
	$query  = "SELECT palabra FROM $tabla WHERE ( (CHAR_LENGTH(palabra) <= $lMax) AND (CHAR_LENGTH(palabra) >= $lMin) )";
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		
		foreach($seeds as $s){
			$lev = levenshtein($s, $row['palabra']);
			if($lev==$d){
				if($d==1){
					array_push($palabras,$row['palabra']);
				} else {
					similar_text($s,$row['palabra'],$sim);
					if($sim>=80){
						array_push($palabras,$row['palabra']);
					}
				}
			}
		}
	}
	
	mysql_close($dbh);
	
	return $palabras;
}



?>