function mostrarArbol(){
    
    /*document.getElementById("btArbol").disabled = "disabled";
    if(hayServidor){
	document.getElementById("btPrueba").disabled = "";
    }*/
    
    var nodo1 = crearArbol(exprExt);
    
    removePalsAfins();
    desplegarArbol(nodo1);
}

function desplegarArbol(nodo1){
    
    var canvas = document.createElement("canvas");
    canvas.id = "canvasArbol"
    document.getElementById("zonaDespliegue").appendChild(canvas);
    var depth = getDepth(nodo1,1);
    var ancho = getAncho(nodo1);
    $('#canvasArbol').css("height",60+((depth-1)*100)+"px");
    $('#canvasArbol').css("width",(ancho*120)+"px");
    canvas.height = 60+((depth-1)*100);
    canvas.width = ancho*120;
    
    dibujar(nodo1,$('#canvasArbol').width(),0,0);
}

function getDepth(nodo,d){
    if(nodo.children.length>0){
	d++;
	for(var i=0;i<nodo.children.length;i++){
	    var dChild = getDepth(nodo.children[i],d);
	    if(dChild>d){
		d = dChild;
	    }
	}
    } else {
	d = d;
    } 
    return d;
}

function getAncho(nodo){
    var w;
    if(nodo.children.length>0){
	w = 0;
	for(var i=0;i<nodo.children.length;i++){
	    w += getAncho(nodo.children[i]);
	}
    } else {
	w = 1;
    } 
    return w;
}


function dibujar(nodo,w,iniX,nivY){
    
    var re = /[&\/!-\>\+_#]/;
    var r;
    var toks = new Array();
    
    var pals = nodo.token.split(",");
    var pal = pals[0];
    
    var canvas = document.getElementById("canvasArbol");
    var cntxt = canvas.getContext('2d');
    if(re.test(pal)){
	cntxt.fillStyle='#dede33';
	var operadores = new Array(/\&\&/,/\/\//,/\!/,/#/,/\+\+/,/-\>/,/\&\+/);
	var operadoresOrig = new Array('AND','OR','NOT','NEG','MAS','CAU','SEG');
	toks.push(pal.replaceArray(operadores,operadoresOrig));
	r = 25;
    } else {
	if(pals.length>1){
	    pal+=",...";
	}
	cntxt.fillStyle='#33dede';
	r = 32;
	if(pal.length>6){
	    var reVocal = /[aeiouáéíóúü]/;
	    for(var i=6;i>0;i--){
		if(pal.charAt(i)=="," || ( (!(reVocal.test(pal.charAt(i)))) && reVocal.test(pal.charAt(i-1)) ) ){
		    toks.push(pal.substring(0,i));
		    pal = pal.substring(i,pal.length);
		    if(pal.length>6){
			i=6;
		    } else {
			toks.push(pal);
			break;
		    }
		}
	    }
	} else {
	    toks.push(pal);
	}
    } 
    cntxt.beginPath();
    cntxt.arc((w/2)+iniX,nivY+10+r,r,0,2*Math.PI);
    cntxt.fill();
    
    for(var t=0;t<toks.length;t++){
	cntxt.beginPath();
	cntxt.lineWidth="1";
	cntxt.strokeStyle='#555555';
	cntxt.font="12px Arial";
	cntxt.strokeText(toks[t],(w/2)+iniX-(r/2),nivY+10+(r/toks.length*(t+1))+((r/5)*(toks.length-1))); 
    }

    for(var i=0;i<nodo.children.length;i++){
	
	cntxt.beginPath();
	cntxt.lineWidth="3";
	cntxt.strokeStyle='#dede33';
	cntxt.moveTo((w/2)+iniX,nivY+10+(2*r));
	cntxt.lineTo((w/nodo.children.length/2)+(iniX+((w/nodo.children.length)*i)),(nivY+(r*2)+40)+10+r);
	cntxt.stroke();
	
	dibujar(nodo.children[i],w/nodo.children.length,iniX+((w/nodo.children.length)*i),nivY+(r*2)+40);
    }

}
