<?PHP
// Original PHP code by Chirp Internet: www.chirp.com.au
// Please acknowledge use of this code by including this header.

/*
Formato del response xml:

<response>
  <verb>
    <ss id="">
      <rel nom="" pals="" />
      <rel nom="" pals="" />
    </ss>
  </verb>
  <sust>
    <ss id="">
      <rel nom="" pals="" />
      <rel nom="" pals="" />
    </ss>
  </sust>
  <adj>
    <ss id="">
      <rel nom="" pals="" />
      <rel nom="" pals="" />
    </ss>
  </adj>
</response>
 
*/

//mb_internal_encoding("UTF-8");

class xmlResponse
{

  function start()
  {
    header('Content-Type: text/xml');
    echo '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' . "\n";
    echo "<response>\n";
  }

  //function command($tipoPal, $rels, $params=array(), $encoded=array())
  function command($tipoPal, $rels=array(), $synsets=array()){
    echo "  <$tipoPal>\n";
    foreach($synsets as $ss => $pals){
      echo "    <ss id=\"$ss\" >\n";
      $arrPals = split("\|",$pals);
      for($i=0;$i<count($rels);$i++){
        if($arrPals[$i]!=null && $arrPals[$i]!=""){
          echo "    <rel nom=\"$rels[$i]\" pals=\"$arrPals[$i]\" />\n";
        }
      }
      echo "    </ss>\n";
    }
    echo "  </$tipoPal>\n";
    
    
    /*
    if($synsets) {
      foreach($synsets as $ss => $pals) {
        echo "    <$ss>" . htmlspecialchars($val) . "</$key>\n";
      }
    }
    
    if($encoded) {
      foreach($encoded as $key => $val) {
        echo "    <$key><![CDATA[$val]]></$key>\n";
      }
    }
    */

  }

  function end()
  {
    echo "</response>\n";
    exit;
  }

}
?>
