<?php

header('Content-Type: text/html; charset=utf-8');

include 'funcionesCompartidas.php';
include 'expresionesEquivalentes_editor.php';

// en eswn_synset, los synsets aparecen máx. una vez por POS
// cuando hay gloss en esWN-synset, no hay más sinónimos en esWM-variant

///return string type Sinónimos|Hipónimos|Hiperónimos--synset1::def1|hip1,hip2,hip3|hiper1,hiper2&&synset2::def1|hip1,hip2,hip3|hiper1,hiper2---
/*
RELACIONES CON VERBOS
has_hyponym: v-v
causes:  v-v
///has_subevent:  v-v
///see_also_wn15:  v-v
xpos_near_synonym:  n-v
near_antonym:  v-v
role:  n-v
role_agent:   n-v
role_instrument:   n-v
role_patient:   n-v
role_location:  n-v
xpos_fuzzynym:  n-v
*/

$pal = urldecode($_POST["q"]);
$tipoPal="";

$relacionesV="V:Sinónimos|Hipónimos|Hiperónimos|Es causa de|Es consecuencia de|Tiene sub-evento|Es sub-evento de|Casi-sinónimo con xPos|xpos_fuzzynym|Antónimos|Role|Role-agent|Role-instrument|Role-patient|Role-location|see_also_wn15|Verbo-sust-adj|Expresiones equivalentes";
$relacionesN="N:Sinónimos|Hipónimos|Hiperónimos|xpos_near_synonym|xpos_hyponym|xpos_fuzzynym|near_antonym|has_holo_part|has_holo_member|has_mero_part|be_in_state|pertains_to|Role|Role-agent|Role-instrument|Role-patient|Role-location|Verbo-sust-adj|Expresiones equivalentes";
$relacionesA="A:Sinónimos|near_synonym|xpos_near_synonym|has_xpos_hyponym|near_antonym|pertains_to|has_derived|be_in_state|see_also_wn15|Verbo-sust-adj|Expresiones equivalentes";

$synsets=array();
$synsetsV=array();
$synsetsN=array();
$synsetsA=array();

$dbh = connectToDB();
mysql_select_db("esWN", $dbh);

$query  = "SELECT * FROM eswn_variant_utf8 WHERE word='$pal'"; 
$result = mysql_query($query,$dbh);
while($row = mysql_fetch_array($result)){
	$ss = $row['offset'];
	$synsets[$ss] = $row['pos'];
}

foreach($synsets as $ss=>$pos){
	
	$str = $ss."::";
	$str .= getSinonimos($ss);
	
	if($pos=="v"){
		
		// get hipónimos, hiperónimos, xpos_near_synonym, role_agent, role_instrument, role
		$str .= "|".getPalsRels_source($ss,'has_hyponym');
		$str .= "|".getPalsRels_target($ss,'has_hyponym');
		$str .= "|".getPalsRels_source($ss,'causes');
		$str .= "|".getPalsRels_target($ss,'causes');
		$str .= "|".getPalsRels_source($ss,'has_subevent');
		$str .= "|".getPalsRels_target($ss,'has_subevent');
		$str .= "|".getPalsRels_target($ss,'xpos_near_synonym');
		$str .= "|".getPalsRels_target($ss,'xpos_fuzzynym');
		$str .= "|".getPalsRels($ss,'near_antonym');
		$str .= "|".getPalsRels_target($ss,'role');
		$str .= "|".getPalsRels_target($ss,'role_agent');
		$str .= "|".getPalsRels_target($ss,'role_instrument');
		$str .= "|".getPalsRels_target($ss,'role_patient');
		$str .= "|".getPalsRels_target($ss,'role_location');
		$str .= "|".getPalsRels($ss,'see_also_wn15');

		
		array_push($synsetsV,$str);
	
	} else if($pos=='n'){
		
		//has_hyponym:n-n, has_holo_part:n-n, has_holo_member: n-n, has_mero_part: n-n, pertains_to: a-n, be_in_state: n-a
		//role:  n-v, role_agent:   n-v, role_instrument:   n-v, role_patient:   n-v, role_location:  n-v
		//near_antonym: n-n, xpos_near_synonym: n-v/n-a/a-n, has_xpos_hyponym: n-a, xpos_fuzzynym: n-v
		$str .= "|".getPalsRels_source($ss,'has_hyponym');
		$str .= "|".getPalsRels_target($ss,'has_hyponym');
		$str .= "|".getPalsRels($ss,'xpos_near_synonym');
		$str .= "|".getPalsRels_source($ss,'has_xpos_hyponym');
		$str .= "|".getPalsRels_source($ss,'xpos_fuzzynym');
		$str .= "|".getPalsRels($ss,'near_antonym');
		$str .= "|".getPalsRels($ss,'has_holo_part');
		$str .= "|".getPalsRels($ss,'has_holo_member');
		$str .= "|".getPalsRels($ss,'has_mero_part');
		$str .= "|".getPalsRels_source($ss,'be_in_state');
		$str .= "|".getPalsRels_target($ss,'pertains_to');
		$str .= "|".getPalsRels_source($ss,'role');
		$str .= "|".getPalsRels_source($ss,'role_agent');
		$str .= "|".getPalsRels_source($ss,'role_instrument');
		$str .= "|".getPalsRels_source($ss,'role_patient');
		$str .= "|".getPalsRels_source($ss,'role_location');
		
		array_push($synsetsN,$str);
		
	} else if($pos=='a'){
		
		//near_synonym: a-a, near_antonym: a-a, pertains_to: a-n; be_in_state:  n-a; see_also_wn15:  a-a; has_derived: r-a; 
		//xpos_near_synonym: n-a/a-n, has_xpos_hyponym: n-a
		$str .= "|".getPalsRels($ss,'near_synonym');
		$str .= "|".getPalsRels($ss,'xpos_near_synonym');
		$str .= "|".getPalsRels_target($ss,'has_xpos_hyponym');
		$str .= "|".getPalsRels($ss,'near_antonym');
		$str .= "|".getPalsRels_source($ss,'pertains_to');
		$str .= "|".getPalsRels_target($ss,'has_derived');
		$str .= "|".getPalsRels_target($ss,'be_in_state');
		$str .= "|".getPalsRels_target($ss,'see_also_wn15');

		array_push($synsetsA,$str);
	}
}

$str = "Todos los synsets::";
if($pos=='n'){
	$str .= "|||||||||||||||||";
	$str .= join(", ",getVerbSustAdj($pal));
	$str .= "|".getExprEq($pal);
	array_push($synsetsN,$str);
} elseif($pos=='a'){
	$str .= "|||||||||";
	$str .= join(", ",getVerbSustAdj($pal));
	$str .= "|".getExprEq($pal);
	array_push($synsetsA,$str);
} elseif($pos=='v'){
	$str .= "||||||||||||||||";
	$str .= join(", ",getVerbSustAdj($pal));
	$str .= "|".getExprEq($pal);
	array_push($synsetsV,$str);
}

mysql_close($dbh);



$res="";
if(count($synsetsV)>0 && ($tipoPal==""||$tipoPal=="v") ){
		$res = $relacionesV . "--" . join("&&",$synsetsV);
}
if(count($synsetsN)>0 && ($tipoPal==""||$tipoPal=="n") ){
	if($res==""){
		$res = $relacionesN . "--" . join("&&",$synsetsN);
	} else {
		$res = $res."---".$relacionesN . "--" . join("&&",$synsetsN);
	}
}
if(count($synsetsA)>0 && ($tipoPal==""||$tipoPal=="a") ){
	if($res==""){
		$res = $relacionesA . "--" . join("&&",$synsetsA);
	} else {
		$res = $res."---".$relacionesA . "--" . join("&&",$synsetsA);
	}
}
echo $res;




///FUNCIONES && QUERIES DB


function getSinonimos($ss){

	global $pal, $dbh;
	$syns = "";
	
	$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$ss'"; 
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		if($row['word']!=$pal){
			$word = $row['word'];
			$word = preg_replace('/_/',' ', $word);
			$syns = $syns.$word.", ";
		}
	}
	
	if($syns!=""){
		$syns = substr($syns, 0, -2);
	} 
	
	return $syns;
}



function getPalsRels($ss,$rel){
	
	global $pal, $dbh;
	$newSynsets=array();
	$newPals=array();
	$str = "";
	
	$query  = "SELECT * FROM eswn_relation WHERE ( ( (sourceSynset='$ss') OR (targetSynset='$ss') ) AND (relation='$rel') )";
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		if($row['targetSynset']==$ss){
			array_push($newSynsets,$row['sourceSynset']);
		} else {
			array_push($newSynsets,$row['targetSynset']);
		}
	}
	
	for($n=0;$n<count($newSynsets);$n++){
		$newSs = $newSynsets[$n];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$newSs'";
		$result = mysql_query($query,$dbh);
		while($row = mysql_fetch_array($result)){
			if(yaEstaEnArray($row['word'],$newPals)=="no"){
				$word = $row['word'];
				$word = preg_replace('/_/',' ', $word);
				array_push($newPals,$word);
			}
		}
	}
	
	$str = join(", ",$newPals);
	return $str;
}



function getPalsRels_source($ss,$rel){
	
	global $pal, $dbh;
	$newSynsets=array();
	$newPals=array();
	$str = "";
	
	$query  = "SELECT * FROM eswn_relation WHERE ( (sourceSynset='$ss') AND (relation='$rel') )";
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		array_push($newSynsets,$row['targetSynset']);
	}
	for($n=0;$n<count($newSynsets);$n++){
		$newSs = $newSynsets[$n];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$newSs'";
		$result = mysql_query($query,$dbh);
		while($row = mysql_fetch_array($result)){
			if(yaEstaEnArray($row['word'],$newPals)=="no"){
				$word = $row['word'];
				$word = preg_replace('/_/', ' ', $word);
				array_push($newPals,$word);
			}
		}
	}
	
	$str = join(", ",$newPals);
	return $str;
}


function getPalsRels_target($ss,$rel){
	
	global $pal, $dbh;
	$newSynsets=array();
	$newPals=array();
	$str = "";
	
	$query  = "SELECT * FROM eswn_relation WHERE ( (targetSynset='$ss') AND (relation='$rel') )";
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		array_push($newSynsets,$row['sourceSynset']);
	}
	for($n=0;$n<count($newSynsets);$n++){
		$newSs = $newSynsets[$n];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$newSs'";
		$result = mysql_query($query,$dbh);
		while($row = mysql_fetch_array($result)){
			if(yaEstaEnArray($row['word'],$newPals)=="no"){ //&&$row['word']!=$pal
				$word = $row['word'];
				$word = preg_replace('/_/',' ', $word);
				array_push($newPals,$word);
			}
		}
	}
	
	$str = join(", ",$newPals);
	return $str;
}


function yaEstaEnArray($w,$arr){
	$ya = "no";
	for($i=0;$i<count($arr);$i++){
		if($arr[$i]==$w){
			$ya = "si";	
			break;
		}
	}
	return $ya;	
}


?>